#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	
	
	ofBackground(40,0,0);
	
	cell1.loadImage("cell1.png");
	back.loadImage("back.jpg");
	
	
	ofSetVerticalSync(true);
	ofSetFrameRate(60);
	
	
	for (int i = 0; i < 100; i++){
		particle myParticle;
		myParticle.setInitialCondition(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()),0,0);
		myParticle.cell1 = &cell1;
		myParticle.size = ofRandom (80,150);
		myParticle.alpha = ofRandom (20,80);
		myParticle.rotateCell= ofRandom(0,360);
		particles.push_back(myParticle);
	}
	
	VF.setupField(60,40,ofGetWidth(), ofGetHeight());
	VF.randomizeField(2.0);
	
	drawingStyle = 0;
	bFade = true;
	
	
}

//--------------------------------------------------------------
void testApp::update(){
	
	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].resetForce();
		
		
	}
	
	
	
	//////
	
	for (int i = 0; i < particles.size(); i++){
		
		particles[i].addRepulsionForce(mouseX, mouseY, 200, 0.5f);
		particles[i].addAttractionForce(mouseX, mouseY, 1000, 0.5f);

		
		
		for (int j = 0; j < i; j++){
			particles[i].addRepulsionForce(particles[j], 200, 0.1);
			particles[i].addCounterClockwiseForce(particles[j], 800, 0.001);
			particles[i].addClockwiseForce(particles[j], 600, 0.01);
		}
	}
	
	for (int i = 0; i < particles.size(); i++){
		ofxVec2f frc;
		frc = VF.getForceFromPos(particles[i].pos.x, particles[i].pos.y);
		particles[i].addForce(frc.x, frc.y);
		particles[i].addDampingForce();
		particles[i].update();
	}
	if (bFade == true) VF.fadeField(0.99f);
}

//--------------------------------------------------------------
void testApp::draw(){
	ofSetColor(255,255,255);
	back.draw(0,0);
	
	ofEnableAlphaBlending();

	//VF.draw();
	
	
	
	
	//ofSetColor(0x000000);
	
	for (int i = 0; i < particles.size(); i++){
	
		particles[i].draw();

	}
	ofSetColor(0,130,130, 200);
	//ofRect(30,30,300,75);
	ofSetColor(255,255,255, 230);
	ofDrawBitmapString("space to clear\nchange drawing mode 'a'\ntoggle fade 'f'", 50, 50);
	
	ofSetColor(255,255,130, 20);
	switch (drawingStyle){
		case 0: ofDrawBitmapString("drawing mode: inward", 50, 90);
			break;
		case 1: ofDrawBitmapString("drawing mode: outward", 50, 90);
			break;
		case 2: ofDrawBitmapString("drawing mode: clockwise", 50, 90);
			break;
		case 3: ofDrawBitmapString("drawing mode: counter-clockwise", 50, 90); 
			break;
	}	
}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
	
	switch (key){
			
		case ' ':
			// reposition everything: 
			for (int i = 0; i < particles.size(); i++){
				particles[i].setInitialCondition(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()),0,0);
			}
			break;
		case 'f':
			bFade = !bFade;
			break;
		case 'a':
			drawingStyle ++;
			drawingStyle %= 4;
			break;
			
	}
	
	
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	if (button == 0) {
		switch (drawingStyle){
			case 0: VF.addInwardCircle((float)x, (float)y, 200, 0.3f);
				break;
			case 1: VF.addOutwardCircle((float)x, (float)y, 500, 0.9f);
				break;
			case 2: VF.addClockwiseCircle((float)x, (float)y, 100, 0.3f);
				break;
			case 3: VF.addCounterClockwiseCircle((float)x, (float)y, 100, 0.3f);
				break;
		}		
	} else {
		
		particles.erase(particles.begin());
		particle myParticle;
		myParticle.setInitialCondition(x,y,0,0);
		particles.push_back(myParticle);
		
		
	}
	
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	
	
	
}

//--------------------------------------------------------------
void testApp::mouseReleased(){
}
